/* auto-generated, do not modify */
#include "config.h"

#include "fu-dfu-csr-struct.h"
#include "fu-byte-array.h"
#include "fu-mem-private.h"
#include "fu-string.h"

#ifdef G_LOG_DOMAIN
  #undef G_LOG_DOMAIN
#endif
#define G_LOG_DOMAIN "FuStruct"


/* getters */
/**
 * fu_struct_dfu_csr_file_get_file_version: (skip):
 **/
static guint16
fu_struct_dfu_csr_file_get_file_version(const FuStructDfuCsrFile *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 8, G_LITTLE_ENDIAN);
}
/**
 * fu_struct_dfu_csr_file_get_file_len: (skip):
 **/
guint32
fu_struct_dfu_csr_file_get_file_len(const FuStructDfuCsrFile *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 10, G_LITTLE_ENDIAN);
}
/**
 * fu_struct_dfu_csr_file_get_file_hdr_len: (skip):
 **/
guint16
fu_struct_dfu_csr_file_get_file_hdr_len(const FuStructDfuCsrFile *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 14, G_LITTLE_ENDIAN);
}

/* setters */
/**
 * fu_struct_dfu_csr_file_to_string: (skip):
 **/
static gchar *
fu_struct_dfu_csr_file_to_string(const FuStructDfuCsrFile *st)
{
    g_autoptr(GString) str = g_string_new("FuStructDfuCsrFile:\n");
    g_return_val_if_fail(st != NULL, NULL);
    g_string_append_printf(str, "  file_len: 0x%x\n",
                           (guint) fu_struct_dfu_csr_file_get_file_len(st));
    g_string_append_printf(str, "  file_hdr_len: 0x%x\n",
                           (guint) fu_struct_dfu_csr_file_get_file_hdr_len(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
static gboolean
fu_struct_dfu_csr_file_validate_internal(FuStructDfuCsrFile *st, GError **error)
{
    g_return_val_if_fail(st != NULL, FALSE);
    if (strncmp((const gchar *) (st->data + 0), "CSR-dfu2", 8) != 0) {
        g_set_error_literal(error,
                            FWUPD_ERROR,
                            FWUPD_ERROR_INVALID_DATA,
                            "constant FuStructDfuCsrFile.file_id was not valid");
        return FALSE;
    }
    if (fu_struct_dfu_csr_file_get_file_version(st) != 0x02) {
        g_set_error_literal(error,
                            FWUPD_ERROR,
                            FWUPD_ERROR_INVALID_DATA,
                            "constant FuStructDfuCsrFile.file_version was not valid");
        return FALSE;
    }
    return TRUE;
}
/**
 * fu_struct_dfu_csr_file_validate_stream: (skip):
 **/
gboolean
fu_struct_dfu_csr_file_validate_stream(GInputStream *stream, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = NULL;
    g_return_val_if_fail(G_IS_INPUT_STREAM(stream), FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    st = fu_input_stream_read_byte_array(stream, offset, 16, error);
    if (st == NULL) {
        g_prefix_error(error, "FuStructDfuCsrFile failed read of 0x%x: ", (guint) 16);
        return FALSE;
    }
    if (st->len != 16) {
        g_set_error(error,
                    FWUPD_ERROR,
                    FWUPD_ERROR_INVALID_DATA,
                    "FuStructDfuCsrFile requested 0x%x and got 0x%x",
                    (guint) 16,
                    (guint) st->len);
        return FALSE;
    }
    return fu_struct_dfu_csr_file_validate_internal(st, error);
}
static gboolean
fu_struct_dfu_csr_file_parse_internal(FuStructDfuCsrFile *st, GError **error)
{
    g_autofree gchar *str = NULL;
    if (!fu_struct_dfu_csr_file_validate_internal(st, error))
        return FALSE;
    str = fu_struct_dfu_csr_file_to_string(st);
    g_debug("%s", str);
    return TRUE;
}
/**
 * fu_struct_dfu_csr_file_parse_stream: (skip):
 **/
FuStructDfuCsrFile *
fu_struct_dfu_csr_file_parse_stream(GInputStream *stream, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = NULL;
    st = fu_input_stream_read_byte_array(stream, offset, 16, error);
    if (st == NULL) {
        g_prefix_error(error, "FuStructDfuCsrFile failed read of 0x%x: ", (guint) 16);
        return NULL;
    }
    if (st->len != 16) {
        g_set_error(error,
                    FWUPD_ERROR,
                    FWUPD_ERROR_INVALID_DATA,
                    "FuStructDfuCsrFile requested 0x%x and got 0x%x",
                    (guint) 16,
                    (guint) st->len);
        return NULL;
    }
    if (!fu_struct_dfu_csr_file_parse_internal(st, error))
        return NULL;
    return g_steal_pointer(&st);
}
/* getters */

/* setters */
/**
 * fu_struct_dfu_csr_command_header_set_report_id: (skip):
 **/
void
fu_struct_dfu_csr_command_header_set_report_id(FuStructDfuCsrCommandHeader *st, FuDfuCsrReportId value)
{
    g_return_if_fail(st != NULL);
    st->data[0] = value;
}
/**
 * fu_struct_dfu_csr_command_header_set_command: (skip):
 **/
void
fu_struct_dfu_csr_command_header_set_command(FuStructDfuCsrCommandHeader *st, FuDfuCsrCommand value)
{
    g_return_if_fail(st != NULL);
    st->data[1] = value;
}
/**
 * fu_struct_dfu_csr_command_header_set_idx: (skip):
 **/
void
fu_struct_dfu_csr_command_header_set_idx(FuStructDfuCsrCommandHeader *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 2, value, G_LITTLE_ENDIAN);
}
/**
 * fu_struct_dfu_csr_command_header_set_chunk_sz: (skip):
 **/
void
fu_struct_dfu_csr_command_header_set_chunk_sz(FuStructDfuCsrCommandHeader *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 4, value, G_LITTLE_ENDIAN);
}
/**
 * fu_struct_dfu_csr_command_header_new: (skip):
 **/
FuStructDfuCsrCommandHeader *
fu_struct_dfu_csr_command_header_new(void)
{
    FuStructDfuCsrCommandHeader *st = g_byte_array_sized_new(6);
    fu_byte_array_set_size(st, 6, 0x0);
    return st;
}
